<%@ Page Language="C#" %>
<%@ Register TagPrefix="anthem" Namespace="Anthem" Assembly="Anthem" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html>
	<head>
		<title>Validation</title>
	</head>
	<body>
		<form id="Form1" method="post" runat="server">
			<p>There are two <code>RequiredFieldValidator</code> controls on this page that 
				require values in the text boxes.</p>
			<p>Clicking any of the buttons should do a call back to the server but only if the 
				page is valid. If the page is not valid, it should show red asterisks next to 
				the text boxes and also display the <code>ValidationSummory</code> control at 
				the bottom of the page.</p>
			<p>Once you fix the validation errors, the asterisks and the summary should 
				disappear and a label should be updated on the page with the current value of 
				the <code>IsValid</code> property on the server.</p>
			<p>This is all done without doing any post backs to the server.</p>
			<div>
				<asp:TextBox ID="textBox1" Runat="server" />
				<asp:RequiredFieldValidator ID="required1" Runat="server" ControlToValidate="textBox1" ErrorMessage="Enter a value into the first text box!">*</asp:RequiredFieldValidator>
				<br />
				<asp:TextBox ID="textbox2" Runat="server" />
				<asp:RequiredFieldValidator ID="required2" Runat="server" ControlToValidate="textBox2" ErrorMessage="Enter a value into the second text box!">*</asp:RequiredFieldValidator>
			</div>
			<br />
			<anthem:Button id="button" runat="server" Text="Click Me!" OnClick="button_Click" />
			<anthem:LinkButton id="linkButton" runat="server" Text="Click Me!" OnClick="button_Click" />
			<anthem:ImageButton id="imageButton" runat="server" ImageUrl="button_run.gif" OnClick="imageButton_Click" />
			<br />
			<anthem:Label id="label" runat="server" />
			<br />
			<asp:ValidationSummary ID="summary" Runat="server" />
		</form>
	</body>
</html>
<script runat="server">

	void button_Click(object sender, EventArgs e)
	{
		label.Text = string.Format("IsValid = {0}", IsValid);
		label.UpdateAfterCallBack = true;
	}
	
	void imageButton_Click(object sender, ImageClickEventArgs e)
	{
		button_Click(sender, e);
	}

</script>
