<%@ Page Language="C#" %>
<%@ Register TagPrefix="anthem" Namespace="Anthem" Assembly="Anthem" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>RedirectingClients</title>
	</HEAD>
	<body>
		<form id="Form1" method="post" runat="server">
			<h2>Description</h2>
			<p>Redirecting clients to new pages during a call back isn't possible using <code>Response.Redirect</code>
				since the browser isn't what's making the request to the server for each call 
				back. Instead, there's JavaScript on the page using <code>XMLHttpRequest</code> 
				to make the call back. Telling the <code>XMLHttpRequest</code> object to 
				redirect is not going to affect the browser one bit.</p>
			<p>Using <code>Anthem.Manager</code>, it's possible to "return" extra JavaScript 
				to the client which can be used to tell the browser to change URLs.</p>
			<h2>Example</h2>
			<anthem:Button id="button" runat="server" Text="Redirect Me!" OnClick="button_Click" />
			<script runat="server">
				void button_Click(object sender, EventArgs e)
				{
					Anthem.Manager.AddScriptForClientSideEval("alert('Bye!')");
					Anthem.Manager.AddScriptForClientSideEval("window.location = 'http://anthem-dot-net.sourceforge.net/';");
				}
			</script>
			<h2>Steps</h2>
			<ol>
				<li>
					<p>Add an <code>anthem:Button</code> control to the page with an event handler 
						specified in its <code>OnClick</code> attribute:</p>
					<pre><code><strong>&lt;anthem:Button id="Button1" runat="server" Text="Redirect Me!" OnClick="Button1_Click" /&gt;</strong></code></pre>
				<li>
					<p>Implement the event handler so that it calls <code>Anthem.Manager.AddScriptForClientSideEval</code>. 
						Into that method pass in the necessary JavaScript to get the browser to change 
						URLs:</p>
					<pre><code><strong>void button_Click(object sender, EventArgs e)
{
	Anthem.Manager.AddScriptForClientSideEval("alert('Bye!')");
	Anthem.Manager.AddScriptForClientSideEval("window.location = 'http://anthem-dot-net.sourceforge.net/';");
}</strong></code></pre>
				</li>
			</ol>
			<h2>Remarks</h2>
			<p>You can add any JavaScript you want to via the <code>AddScriptForClientSideEval</code>
				method. Each script gets evaluated in the order it was added on the server once 
				it gets returned to the client.</p>
		</form>
	</body>
</HTML>
