using System;
using System.ComponentModel;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using ASP = System.Web.UI.WebControls;

// It looks like very little effort was put into making the Calendar control
// customizable which is why this control is such a hack job. Is it too much
// to ask to make your methods protected and virtual, Microsoft?

namespace Anthem
{
    [ToolboxBitmap(typeof(ASP.Calendar))]
    public class Calendar : ASP.Calendar, IUpdatableControl, ICallBackControl
    {
        #region Unique Anthem control code

        protected override void OnSelectionChanged()
        {
            base.OnSelectionChanged();
            UpdateAfterCallBack = true;
        }
        protected override void OnVisibleMonthChanged(DateTime newDate, DateTime previousDate)
        {
            base.OnVisibleMonthChanged(newDate, previousDate);
            UpdateAfterCallBack = true;
        }

        private const string parentTagName = "div";
        private Regex regex = new Regex("href=\"javascript:__doPostBack\\('(.*?)','(.*?)'\\)\"", RegexOptions.Compiled | RegexOptions.IgnoreCase);

        protected override void Render(HtmlTextWriter writer)
        {
#if !V2
            bool DesignMode = this.Context == null;
#endif
            if (!DesignMode)
            {
                // parentTagName must be defined as a private const string field in this class.
                Anthem.Manager.WriteBeginControlMarker(writer, parentTagName, this);
            }
            if (Visible)
            {
                System.IO.StringWriter sw = new System.IO.StringWriter();
                HtmlTextWriter tw = new HtmlTextWriter(sw);
                base.Render(tw);
                string text = sw.ToString();
                foreach (Match match in regex.Matches(text))
                {
                    string newtext = string.Format(
                        "onclick=\"Anthem_FireCallBackEvent(this,event,'{0}','{1}',false,'','','{2}',{3},{4},{5},{6},true,true);return false;\" ",
                        match.Groups[1].Value,
                        match.Groups[2].Value,
                        HttpUtility.HtmlEncode(TextDuringCallBack),
                        EnabledDuringCallBack ? "true" : "false",
                        (PreCallBackFunction == null || PreCallBackFunction.Length == 0) ? "null" : PreCallBackFunction,
                        (PostCallBackFunction == null || PostCallBackFunction.Length == 0) ? "null" : PostCallBackFunction,
                        (CallBackCancelledFunction == null || CallBackCancelledFunction.Length == 0) ? "null" : CallBackCancelledFunction
                    );
                    text = text.Replace(match.Value, newtext + match.Value);
                }

                writer.Write(text);
            }
            if (!DesignMode)
            {
                Anthem.Manager.WriteEndControlMarker(writer, parentTagName, this);
            }
        }

        #endregion

        #region ICallBackControl implementation

        [DefaultValue("")]
        public string CallBackCancelledFunction
        {
            get
            {
                if (null == ViewState["CallBackCancelledFunction"])
                    return string.Empty;
                else
                    return (string)ViewState["CallBackCancelledFunction"];
            }
            set { ViewState["CallBackCancelledFunction"] = value; }
        }

        [DefaultValue(true)]
        public bool EnableCallBack
        {
            get
            {
                if (ViewState["EnableCallBack"] == null)
                    return true;
                else
                    return (bool)ViewState["EnableCallBack"];
            }
            set
            {
                ViewState["EnableCallBack"] = value;
            }
        }

        [DefaultValue(true)]
        public bool EnabledDuringCallBack
        {
            get
            {
                if (null == ViewState["EnabledDuringCallBack"])
                    return true;
                else
                    return (bool)ViewState["EnabledDuringCallBack"];
            }
            set { ViewState["EnabledDuringCallBack"] = value; }
        }

        [DefaultValue("")]
        public string PostCallBackFunction
        {
            get
            {
                if (null == ViewState["PostCallBackFunction"])
                    return string.Empty;
                else
                    return (string)ViewState["PostCallBackFunction"];
            }
            set { ViewState["PostCallBackFunction"] = value; }
        }

        [DefaultValue("")]
        public string PreCallBackFunction
        {
            get
            {
                if (null == ViewState["PreCallBackFunction"])
                    return string.Empty;
                else
                    return (string)ViewState["PreCallBackFunction"];
            }
            set { ViewState["PreCallBackFunction"] = value; }
        }

        [DefaultValue("")]
        public string TextDuringCallBack
        {
            get
            {
                if (null == ViewState["TextDuringCallBack"])
                    return string.Empty;
                else
                    return (string)ViewState["TextDuringCallBack"];
            }
            set { ViewState["TextDuringCallBack"] = value; }
        }

        #endregion

        #region IUpdatableControl implementation

        [DefaultValue(false)]
        public bool AutoUpdateAfterCallBack
        {
            get
            {
                if (ViewState["AutoUpdateAfterCallBack"] == null)
                    return false;
                else
                    return (bool)ViewState["AutoUpdateAfterCallBack"];
            }
            set
            {
                if (value) UpdateAfterCallBack = true;
                ViewState["AutoUpdateAfterCallBack"] = value;
            }
        }

        private bool _updateAfterCallBack = false;

        [Browsable(false), DefaultValue(false)]
        public bool UpdateAfterCallBack
        {
            get { return _updateAfterCallBack; }
            set { _updateAfterCallBack = value; }
        }

        [
        Category("Misc"),
        Description("Fires before the control is rendered with updated values.")
        ]
        public event EventHandler PreUpdate
        {
            add { Events.AddHandler(EventPreUpdateKey, value); }
            remove { Events.RemoveHandler(EventPreUpdateKey, value); }
        }
        private static readonly object EventPreUpdateKey = new object();

        public virtual void OnPreUpdate()
        {
            EventHandler EditHandler = (EventHandler)Events[EventPreUpdateKey];
            if (EditHandler != null)
                EditHandler(this, EventArgs.Empty);
        }

        #endregion

        #region Common Anthem control code

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            Anthem.Manager.Register(this);
        }

#if V2
        public override void RenderControl(HtmlTextWriter writer)
        {
            base.Visible = true;
            base.RenderControl(writer);
        }
#endif

        public override bool Visible
        {
            get
            {
#if !V2
                bool DesignMode = this.Context == null;
#endif
                return Anthem.Manager.GetControlVisible(this, ViewState, DesignMode);
            }
            set { Anthem.Manager.SetControlVisible(ViewState, value); }
        }

        #endregion
    }
}
