#if V2

using System;
using System.ComponentModel;
using System.Drawing;
using System.Web.UI;
using ASP = System.Web.UI.WebControls;
using WebParts = System.Web.UI.WebControls.WebParts;

namespace Anthem
{
    [ToolboxBitmap(typeof(WebParts.WebPartZone))]
    public class WebPartZone : WebParts.WebPartZone, IUpdatableControl
    {
        #region Unique Anthem control code

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            Page.ClientScript.RegisterStartupScript(
                typeof(WebPartZone),
                "hack",
                @"<script type='text/javascript'>

function WebPartManager_SubmitPage(eventTarget, eventArgument) {
    if ((typeof(this.menu) != 'undefined') && (this.menu != null)) {
        this.menu.Hide();
    }
    Anthem_FireEvent(eventTarget, eventArgument, function() { }, null, true, true);
}

function Zone_AddWebPart(webPartElement, webPartTitleElement, allowZoneChange) {
    var webPart = null;
    var zoneIndex = this.webParts.length;

    for (var i = 0; i < this.webParts.length; ++i) {
        if (this.webParts[i].webPartElement.id == webPartElement.id) {
            zoneIndex = i;
            break;
        }
    }

    if (this.allowLayoutChange && __wpm.IsDragDropEnabled()) {
        webPart = new WebPart(webPartElement, webPartTitleElement, this, zoneIndex, allowZoneChange);
    }
    else {
        webPart = new WebPart(webPartElement, null, this, zoneIndex, allowZoneChange);
    }
    this.webParts[zoneIndex] = webPart;
    return webPart;
}

function ReAddWebParts(zoneID) {
    for (var i = 0; i < __wpm.zones.length; ++i) {
        var zone = __wpm.zones[i];
        if (zone.uniqueID == zoneID) {
            for (var j = 0; j < zone.webParts.length; ++j) {
                var webPartID = zone.webParts[j].webPartElement.id;
                var webPart = document.getElementById(webPartID);
                if (webPart) {
                    zone.AddWebPart(webPart, null, false);
                    var webPartVerbs = document.getElementById(webPartID + 'Verbs');
                    var webPartVerbsPopup = document.getElementById(webPartID + 'VerbsPopup');
                    var webPartVerbsMenu = document.getElementById(webPartID + 'VerbsMenu');
                    var menu = new WebPartMenu(webPartVerbs, webPartVerbsPopup, webPartVerbsMenu);
                    menu.itemStyle = '';
                    menu.itemHoverStyle = '';
                    menu.labelHoverColor = '';
                    menu.labelHoverClassName = '';
                }
            }
            break;
        }
    }
}

</script>");
        }

        protected override void MinimizeWebPart(WebParts.WebPart webPart)
        {
            base.MinimizeWebPart(webPart);
            UpdateAndReAddWebParts();
        }

        protected override void RestoreWebPart(WebParts.WebPart webPart)
        {
            base.RestoreWebPart(webPart);
            UpdateAndReAddWebParts();
        }

        protected override void CloseWebPart(System.Web.UI.WebControls.WebParts.WebPart webPart)
        {
            base.CloseWebPart(webPart);
            UpdateAndReAddWebParts();
        }

        private const string parentTagName = "span";
        protected override void Render(HtmlTextWriter writer)
        {
#if !V2
            bool DesignMode = this.Context == null;
#endif
            if (!DesignMode)
            {
                Anthem.Manager.WriteBeginControlMarker(writer, parentTagName, this);
            }
            if (Visible)
            {
                base.Render(writer);
            }
            if (!DesignMode)
            {
                Anthem.Manager.WriteEndControlMarker(writer, parentTagName, this);
            }
        }

        #endregion

        #region IUpdatableControl implementation

        [DefaultValue(false)]
        public bool AutoUpdateAfterCallBack
        {
            get
            {
                if (ViewState["AutoUpdateAfterCallBack"] == null)
                    return false;
                else
                    return (bool)ViewState["AutoUpdateAfterCallBack"];
            }
            set
            {
                if (value) UpdateAfterCallBack = true;
                ViewState["AutoUpdateAfterCallBack"] = value;
            }
        }

        private bool _updateAfterCallBack = false;

        [Browsable(false), DefaultValue(false)]
        public bool UpdateAfterCallBack
        {
            get { return _updateAfterCallBack; }
            set { _updateAfterCallBack = value; }
        }

        [
        Category("Misc"),
        Description("Fires before the control is rendered with updated values.")
        ]
        public event EventHandler PreUpdate
        {
            add { Events.AddHandler(EventPreUpdateKey, value); }
            remove { Events.RemoveHandler(EventPreUpdateKey, value); }
        }
        private static readonly object EventPreUpdateKey = new object();

        public virtual void OnPreUpdate()
        {
            EventHandler EditHandler = (EventHandler)Events[EventPreUpdateKey];
            if (EditHandler != null)
                EditHandler(this, EventArgs.Empty);
        }

        #endregion

        #region Common Anthem control code

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            Anthem.Manager.Register(this);
        }

#if V2
        public override void RenderControl(HtmlTextWriter writer)
        {
            base.Visible = true;
            base.RenderControl(writer);
        }
#endif

        public override bool Visible
        {
            get
            {
#if !V2
                bool DesignMode = this.Context == null;
#endif
                return Anthem.Manager.GetControlVisible(this, ViewState, DesignMode);
            }
            set { Anthem.Manager.SetControlVisible(ViewState, value); }
        }

        #endregion

        #region Private Methods

        private void UpdateAndReAddWebParts()
        {
            UpdateAfterCallBack = true;
            Anthem.Manager.AddScriptForClientSideEval(string.Format("ReAddWebParts('{0}')", ID));
        }

        #endregion
    }
}

#endif
